(defun xo (/ );(e ent etype blkname blk blocktable isopen isitopen acadobj docsbj doc)

; error handler

  (defun *g-err* (msg)
		(princ "\nXref open error")
		(setq *error* curerr)
		(princ)
  )

; function to test if file is able to be opened

	(defun isopen (fname / file)
		(if (findfile fname)
			(if (setq file (open fname "a"))
				(close file)
			)
		)
		file
	)

; function to test if file is already opened by user

	(defun isitopen (dwgname / dwg flag)
	  	(setq flag nil)
		(vlax-for dwg docsobj
			(if	(or
						(= (vl-string-translate "\\" "/" (strcase (vla-get-name dwg)))(strcase dwgname))
						(= (vl-string-translate "\\" "/" (strcase (vla-get-fullname dwg)))(strcase dwgname))
					)
      		(setq flag 'T)
			)
		)
		flag
	)

; function to perform tests and open the drawing requested

	(defun knockknock (dwg / cnt name doc)
		(if (isitopen dwg)
			(progn
				(setq cnt 0)
				(while (not doc)
					(setq name(vl-string-translate "\\" "/" (strcase(vla-get-fullname (vla-item docsobj cnt)))))
					(if (equal name (strcase dwg))
						(setq doc (vla-item docsobj cnt))
						(setq cnt (1+ cnt))
					)
				)
			)
			(progn
				(if (isopen dwg)
					(setq doc(vla-open docsobj dwg))
					(alert (strcat dwg "\nis not able to be opened for editing."))
				)
			)
		)
		(if doc(vla-put-activedocument acadobj doc))
	)


; main program

	(setq curerr *error*
			*error* *g-err*
			acadobj (vlax-get-acad-object)
			docsobj (vla-get-documents acadobj)
			e (entsel "\nPick the XREF you wish to open: ")
	)
	(if e
		(progn
			(setq ent (entget (car e)'("DTL"))
					etype (cdr (assoc 0 ent))
			)				
			(cond
				((equal etype "INSERT")
					(progn
						(setq blk (strcase(cdr (assoc 2 ent)))
								blocktable (tblsearch "BLOCK" blk)
						)
						(if(= 4 (logand (cdr (assoc 70 blocktable)) 4))
							(setq blkname (strcase(vl-string-translate "\\" "/" (strcat (cdr (assoc 1 blocktable))))))
	  					)			
						(if (equal blk "DBUBSYM")
							(progn
								(setq flg t
										e (car e)
								)
								(while flg
									(setq e(entnext e)
											ent (entget e)
									)
									(if(equal (cdr(assoc 0 ent)) "ATTRIB")
										(if (equal (cdr (assoc 2 ent)) "DTL_CD")
											(setq file (cdr(assoc 1 ent))
													flg nil
											)
										)
									)
								)
								(setq blkname(strcase(vl-string-translate "\\" "/" (strcat (getvar "dwgprefix") "details\\" file))))
							)
						)
						(if (not (wcmatch  blkname "*.DWG"))(setq blkname (strcat blkname ".DWG")))
	  					(knockknock blkname)
					)
				)
				((equal etype "TEXT")
					(progn
						(if (assoc -3 ent)
							(progn
								(setq file (substr (cdr(cadadr(assoc -3 ent)))1 4)
										blkname(strcase(vl-string-translate "\\" "/" (strcat (getvar "dwgprefix") "details\\" file ".dwg")))
								)
								(knockknock blkname)
							)
						)
						(princ "\nText is not a Detail Mark")
					)
				)
				(t(princ "\nYou did not Select an Xref of Detail Mark"))
    		)
		)
		(princ "\nNo item selected.")
	)
	(if doc(vlax-release-object doc))
	(vlax-release-object docsobj)
	(vlax-release-object acadobj)					
	(setq *error* curerr)
	(princ)
)

